<script>

  import { beforeUpdate } from 'svelte';

  export let setApp   = null;
  export let number   = '';
  export let contacts = [];
  export let messages = [];

  export let _messages = [];

  beforeUpdate(() => {

    _messages = messages.slice(0).sort((a,b) => b.time - a.time).map(message => {

      const date = new Date(message.time * 1000);

      return {
        ...message,
        _contact: contacts.find(contact => message.from === contact.number) || null,
        _time   : `${date.getHours().toString().padStart(2, '0')}:${date.getMinutes().toString().padStart(2, '0')}`,
      };

    });

  });

</script>

<style>

  .scrollable::-webkit-scrollbar {
    width: 8px;
  }
  
  .scrollable::-webkit-scrollbar-thumb {
    background: #666;
  }

  .scrollable::-webkit-scrollbar-track {
    background: #ddd;
  }

  .app-messages {
    width: calc(100% - 16px);
    height: 100%;
    display: flex;
    flex-direction: row;
  }
  
  .messages {
    display: flex;
    flex-direction: column;
    overflow-y: auto;
    user-select: none;
    padding-right: 8px;
    width: 100%;
  }

  .message {
    padding: 8px;
    border-radius: 8px;
    background-color: rgb(44, 44, 44);
    color: #bdbdbd;
  }

  .message:hover {
    background-color: rgb(54, 54, 54);
  }

  .message:not(:first-child) {
    margin-top: 8px;
  }

  .message-header {
    text-align: center;
    font-weight: bold;
  }

  .message-body {

  }

</style>

<div class="app-messages">

  <div class="messages scrollable">
    {#each _messages as message, index}
        <div class="message" on:mouseup={e => setApp('messagethread', {target: message.from})}>
          <div class="message-header">{message._contact ? message._contact.name : '#' + message.from} | {message._time}</div>
          <div class="message-body">{message.body}</div>
        </div>
    {/each}
  </div>

</div>